<?php  
/* 
Plugin Name: tweetget Widget 
Plugin URI:  http://www.wildbits.de
Description: Simple widget to get the latest tweet form a twitter rss 
Version: 1.0.0 
Author: Thomas Boley
Author URI: http://www.wildbits.de 
*/  

/*

includes

*/

if (!class_exists('templateparser')) {
	include_once ('templateParser_class.php');
}

require_once (ABSPATH . WPINC . '/class-feed.php');

/*

class tweetget

*/

class tweetget extends WP_Widget {  
    
    function tweetget() {  
        parent::WP_Widget(false, $name = 'tweetget');     
    }  
  

    function widget($args, $instance) { 
          
        extract( $args );  
        echo $before_widget; 
        echo $before_title.$instance['title'].$after_title;  
                  	
		// init simplepie

		$twitter_feed = new SimplePie();
		$twitter_feed->set_feed_url('http://twitter.com/statuses/user_timeline/'.$instance['username'].'.rss');
		$twitter_feed->enable_cache(false);
		$twitter_feed->init();
		$twitter_feed->handle_content_type();
		
		// get feed items
		
		$feeditems = array();
		foreach($twitter_feed->get_items() as $item) {
			$temp_title = $item->get_title();
			$temp_title = preg_replace('/'.$instance['username'].':/','',$temp_title);
			array_push ($feeditems,array ('title'=>$temp_title,'link'=>$item->get_link()));
			}
		
		$content = 'ds';
		
	
		$innerTemplate= new  templateparser(PLUGINDIR.'/tweetget/frontend_tmpl.html');
		$innerTemplate->set_parameter('TWEETURL',$feeditems[0]['link']);
		$innerTemplate->set_parameter('TWEET',$feeditems[0]['title']);
		
		$innerTemplate->the_output();
	
	echo $after_widget;   
         
    }  
  
    function update($new_instance, $old_instance) {               
        
        $instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['username'] = strip_tags($new_instance['username']);
		
		return $instance;
    }  
  

    function form($instance) {  
                  
        $title = esc_attr($instance['title']);
        $username = esc_attr($instance['username']);
        
        $innerTemplate= new  templateparser(ABSPATH.PLUGINDIR.'/tweetget/backend_tmpl.html');
        
        $innerTemplate->set_parameter('FIELDTITLEID',$this->get_field_id('title'));
        $innerTemplate->set_parameter('FIELDTITLE',__('Title:'));
        $innerTemplate->set_parameter('FIELDNAMETITLE',$this->get_field_name('title'));
        $innerTemplate->set_parameter('TITLE',$title);
        $innerTemplate->set_parameter('USERNAME',$username);
        $innerTemplate->set_parameter('USERNAMEID',$this->get_field_id('username'));
        $innerTemplate->set_parameter('USERNAMENAME',$this->get_field_name('username'));
           
        
        $innerTemplate->the_output(); 
    }  
}  

add_action('widgets_init', create_function('', 'return register_widget("tweetget");'));  
?>